rmdir
===

用来删除空目录

## 补充说明

**rmdir命令** 用来删除空目录。当目录不再被使用时，或者磁盘空间已到达使用限定值，就需要删除失去使用价值的目录。利用rmdir命令可以从一个目录中删除一个或多个空的子目录。该命令从一个目录中删除一个或多个子目录，其中dirname佬表示目录名。如果dirname中没有指定路径，则删除当前目录下由dirname指定的目录；如dirname中包含路径，则删除指定位置的目录。删除目录时，必须具有对其父目录的写权限。

注意：子目录被删除之前应该是空目录。就是说，该目录中的所有文件必须用rm命令全部，另外，当前工作目录必须在被删除目录之上，不能是被删除目录本身，也不能是被删除目录的子目录。

虽然还可以用带有`-r`选项的rm命令递归删除一个目录中的所有文件和该目录本身，但是这样做存在很大的危险性。

###  语法 

```shell
rmdir(选项)(参数)
```

###  选项 

```shell
-p或--parents：删除指定目录后，若该目录的上层目录已变成空目录，则将其一并删除；
--ignore-fail-on-non-empty：此选项使rmdir命令忽略由于删除非空目录时导致的错误信息；
-v或-verboes：显示命令的详细执行过程；
--help：显示命令的帮助信息；
--version：显示命令的版本信息。
```

###  参数 

目录列表：要删除的空目录列表。当删除多个空目录时，目录名之间使用空格隔开。

###  实例 

将工作目录下，名为 `www` 的子目录删除 :

```shell
rmdir www
```

在工作目录下的 www 目录中，删除名为 Test 的子目录。若 Test 删除后，www 目录成为空目录，则 www 亦予删除。

```shell
rmdir -p www/Test
```

下面命令等价于 `rmdir a/b/c`, `rmdir a/b`, `rmdir a`

```shell
rmdir -p a/b/c
```



